import { PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsUsercourserecord {
  [PrimaryKeyProp]?: 'Id';
  Id!: bigint;
  UserId!: bigint;
  CourseId!: bigint;
  ViewTime!: number;
  ViewTotal!: number;
  Revision!: number;
  CreatedBy?: bigint;
  CreatedTime!: Date;
  UpdatedBy?: bigint;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsUsercourserecordSchema = defineEntity({
  class: ScsUsercourserecord,
  comment: '课程观看记录',
  properties: {
    Id: p.bigint().primary().name('Id').unsigned(false).autoincrement(false).comment('主键Id'),
    UserId: p.bigint().name('UserId').comment('用户id'),
    CourseId: p.bigint().name('CourseId').comment('课程id'),
    ViewTime: p.integer().name('ViewTime').comment('观看时间'),
    ViewTotal: p.integer().name('ViewTotal').comment('观看次数'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
